local Zifnabs_release="r131012a" 
--local Zifnabs_RESET_Data=true

local Zifnabs_DefaultSettings = {
		["point"] = "CENTER",
		["relativePoint"] = "CENTER",
		["relativeTo"] = "UIParent",
		["offsetX"] = 0,
		["offsetY"] = 0,
		["visible"] = true,
		["monitor_hp"]={["monitor"]=true,["value"]=0.4,["hud"]=true,["sound"]=true},
		["monitor_buffs"]={["monitor"]=true,["value"]=20,["hud"]=true,["sound"]=true},
		["monitor_fps"]={["monitor"]=true,["red"]=9,["yellow"]=16,["green"]=25},
		["remind"]={["hud"]=true,["sound"]=true},
		["reloadui"] = true,
		["button"]={[1]="hi",[2]="bye",[3]="danke"},
		["say"]={
			["hi"] = {
				["notarget"]={"Hallo zusammen","Seid mir gegrüßt, alle zusammen"},
				["any"]={"Hallo, %t","Sei mir gegrüßt, %t"},
				["male"]={"Schön, Dich zu sehen, %t"},
				["female"]={"Wie schön, Dich zu sehen, %t", "Sei mir gegrüßt, holde %t"},
			},
			["bye"]={
				["notarget"]={"Ciao","Auf Wiedersehen","Lebt wohl alle miteinander"},
				["any"]={"Auf Wiedersehen, %t","Lebewohl, %t", "Gute Wege, %t"},
				["male"]={"Mach's gut, %t"},
				["female"]={},
			},
			["danke"]={
					["notarget"]={"Danke","Vielen Dank"},
					["any"]={"Vielen Dank, %t", "Ich danke Euch, %t", "Seid bedankt, %t"},
					["female"]={},
					["male"]={},
			},
		},
}

local on=true
local loaded=nil
local timer=0
local timer_action={}
local FPStimer=0
local FPSupdates=0
local FPStext=nil
local arrange_categories={"notarget","any","female","male"}
local config_frames={["options"]="Options",["buttons"]="Buttons",["texts"]="Texts",["timer"]="Timer"}
local edit_button=0
local monitorhp=0
local monitorhpalarm=-99
local monitorbufalarm=-99
local monitorbufs={}
local hudtime=-1
local hudcolor={1,0.5,0}
local hudflip=1

-- ******************************************************************************************
-- * ON LOAD
-- ******************************************************************************************

function Zifnabs_OnLoad(this)
	zif_echo(Zifnabs_release.." wird geladen")
	this:RegisterEvent("SAVE_VARIABLES")
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("UNIT_TARGET_CHANGED")
	this:RegisterEvent("COMBATMETER_DAMAGE")
	this:RegisterEvent("LOADING_END")
	SaveVariables("Zifnabs_Settings")  -- settings are saved to this table
	FPStext=getglobal("Zifnabs_FPS_Text")
end

-- ******************************************************************************************
-- * SLASH COMMANDS
-- ******************************************************************************************

SLASH_Zifnabs1="/zif"
SlashCmdList["Zifnabs"]=function(editBox,command)
	zif_command(command)
end
function zif_command(command)
	local word1,parm=zif_parse(command)
	word1=string.lower(word1)
	local word2,parm2=zif_parse(parm)
	word2=string.lower(word2)
	if (word1=="hide" and parm=="") then
		zif_config_set_show(false)	
	elseif (word1=="show" and parm=="") then
		zif_config_set_show(true)
	elseif (word1=="config") then
		zif_config("start")
	elseif (word1=="reset") then
		getglobal("Zifnabs"):ClearAllAnchors()
		getglobal("Zifnabs"):SetAnchor("CENTER","UIParent","CENTER",0,0);
		getglobal("Zifnabs"):Show()
		zif_onevent(getglobal("Zifnabs_Script_Control"),"SAVE_VARIABLES")
	elseif (word1=="timer") then 
		zif_Timer_set(word2,"remind "..parm2)
		zif_echo("Timer gesetzt")
	elseif (word1=="do" and Zifnabs_Settings["say"][word2]) then
		zif_tell(word2)
	elseif (word1=="do") then
		zif_error("Button "..word2.." ist nicht definiert")
	elseif (word1=="list" and word2=="timers") then
		for t=1,#timer_action,1 do
			local delta=math.ceil(10*(timer_action[t]["timer"]-timer))/10
			zif_echo("in "..delta.."s : "..timer_action[t]["command"])
		end
	elseif (word1=="off") then
		on=false
		zif_echo("Sämtliche automatischen Funktionen abgeschaltet. Wieder einschalten mit /zif on")
	elseif (word1=="on") then
		on=true
		zif_echo("Automatische Funktionen wieder eingeschaltet")
	else
		zif_error("unbekannter Befehl '"..word1.."'")
	end	
end

-- ******************************************************************************************
-- * ON EVENT
-- ******************************************************************************************

function Zifnabs_OnEvent(this, event)
	if on then
		zif_onevent(this,event)
	end
end
function zif_onevent(this,event)
	if ( event == "UNIT_TARGET_CHANGED" ) then
	elseif ( event == "COMBATMETER_DAMAGE" ) then
	elseif ( event == "LOADING_END" ) then
	elseif ( event == "SAVE_VARIABLES" ) then
		local point, relativePoint, relativeTo, x, y = getglobal("Zifnabs"):GetAnchor()
		assert(Zifnabs_Settings, "[Zifnabs:SAVE_VARIABLES] Zifnabs_Settings variable is nil!" )
		Zifnabs_Settings.point = point
		Zifnabs_Settings.relativePoint = relativePoint
		Zifnabs_Settings.relativeTo = relativeTo:GetName()
		Zifnabs_Settings.offsetX = x
		Zifnabs_Settings.offsetY = y
		zif_echo("Einstellungen gespeichert")

	elseif ( event == "VARIABLES_LOADED" ) then
		if Zifnabs_RESET_Data then
			Zifnabs_Settings=nil			
			zif_error("RESET! ********************")
			zif_error("RESET! ALLE DATEN GELÖSCHT!")
			zif_error("RESET! ********************")
		end
		if not Zifnabs_Settings then
			Zifnabs_Settings={}
			Zifnabs_Settings=Zifnabs_DefaultSettings
			zif_echo("Default-Einstellungen geladen")
		else
			zif_echo("Prüfe Einstellungen")
			for item,value in pairs(Zifnabs_DefaultSettings) do
				if not Zifnabs_Settings[item] then
					zif_echo("Füge neue Einstellung "..item.." ein")
					if type(Zifnabs_DefaultSettings[item])=="table" then
						Zifnabs_Settings[item]={}
						local ttable=Zifnabs_DefaultSettings[item]
						for titem,tvalue in pairs(ttable) do
							Zifnabs_Settings[item][titem]=tvalue
						end
					else
						Zifnabs_Settings[item]=Zifnabs_DefaultSettings[item]
					end
				end
			end
			if Zifnabs_Settings.monitorhp then
				Zifnabs_Settings.monitorhp=nil
				Zifnabs_Settings.monitorhpwarn=nil
				Zifnabs_Settings.monitorbufs=nil
				Zifnabs_Settings.monitorbufstime=nil
				Zifnabs_Settings.monitorhpcolors=nil
			end
		end
		
		getglobal("Zifnabs"):ClearAllAnchors()
		getglobal("Zifnabs"):SetAnchor(Zifnabs_Settings.point, Zifnabs_Settings.relativePoint, Zifnabs_Settings.relativeTo, Zifnabs_Settings.offsetX, Zifnabs_Settings.offsetY)
		getglobal("Zifnabs_Config_Options_Monitor_HP_check_Text"):SetText("HP überwachen")
		getglobal("Zifnabs_Config_Options_Monitor_Buffs_check_Text"):SetText("Bufs überwachen")
		getglobal("Zifnabs_Config_Options_Monitor_FPS_check_Text"):SetText("FPS überwachen")
	else
		zif_error("undefinierter Event "..event..", arg1="..arg1)
	end	
end

-- ******************************************************************************************
-- * TIMER
-- ******************************************************************************************

function Zifnabs_OnUpdate(this, elapsed)
	if on then
		zif_onupdate(this,elapsed)
	end
end
function zif_onupdate(this,elapsed)
	timer=timer+elapsed
	if not loaded then
		if Zifnabs_Settings then
			zif_echo("Einstellungen geladen")
			loaded=1
			zif_display()
			zif_Timer_set(30,"check1")
		end
	end
	if timer_action[1] then
		if timer>=timer_action[1]["timer"] then
			zif_Timer_execute(timer_action[1]["command"])
			table.remove(timer_action,1)
		end
	end
	FPSupdates=FPSupdates+1
	local deltaFPS=timer-FPStimer
	if deltaFPS>1 then
		local red=Zifnabs_Settings.monitor_fps.red
		local yellow=Zifnabs_Settings.monitor_fps.yellow
		local green=Zifnabs_Settings.monitor_fps.green
		local fps=math.ceil(0.5+FPSupdates/deltaFPS)
		FPStimer=timer
		FPSupdates=0
		if Zifnabs_Settings.monitor_fps.monitor==true then
			FPStext:SetText(fps)
			if fps< yellow then
				r=1
				g=math.max(0,fps-red)/(yellow-red)
			else
				g=1
				r=math.max(0,green-fps)/(green-yellow)
			end
			FPStext:SetColor(r,g,0)
		end
	end
	if deltaFPS>1 and Zifnabs_Settings.monitor_hp.monitor==true then
		local health=UnitHealth("player")
		local maxhealth=UnitMaxHealth("player")
		if health<monitorhp then
			if health/maxhealth<Zifnabs_Settings.monitor_hp.value then
				if timer-monitorhpalarm>15 then
					zif_HUD(Zifnabs_Settings.monitor_hp,"aaaah.mp3","HP auf "..health.."!")
				end
				monitorhpalarm=timer
			end
		elseif health/maxhealth>Zifnabs_Settings.monitor_hp.value+0.2 then
			monitorhpalarm=0
		end
		monitorhp=health
	end
	if deltaFPS>1 and Zifnabs_Settings.monitor_buffs.monitor==true then
		local newbufs={}
		local mintime=Zifnabs_Settings.monitor_buffs.value
		for buf=1,20,1 do
			local bufname=UnitBuff("player",buf)
			if bufname then
				local remain=UnitBuffLeftTime("player",buf)
				if remain>mintime then
					if monitorbufs[bufname] then
						newbufs[bufname]=monitorbufs[bufname]
					else
						newbufs[bufname]=remain
					end
				elseif monitorbufs[bufname]>mintime then
					zif_echo(bufname.." |cffff0000<"..mintime.."s Restzeit!|r")
					if timer-monitorbufalarm>5 then
						zif_HUD(Zifnabs_Settings.monitor_buffs,"dingdong.mp3",bufname.." <"..mintime.."s")
					end
					monitorbufalarm=timer
				end
			end
		end
		monitorbufs=newbufs
	end
	if hudtime>0 then
		hudtime=hudtime-elapsed
		if hudtime<=0 then
			getglobal("Zifnabs_HUD"):Hide()
		elseif hudtime<=2.5 then
			hudcolor[0]=hudcolor[0]-elapsed/3
			hudcolor[1]=hudcolor[1]-elapsed/2.5
			hudcolor[2]=hudcolor[2]+elapsed/10
			getglobal("Zifnabs_HUD__Text"):SetColor(hudcolor[0],hudcolor[1],hudcolor[2])
		elseif hudflip==1 then
			getglobal("Zifnabs_HUD__Text"):SetColor(1,0,0)
		elseif hudflip==0 then
			getglobal("Zifnabs_HUD__Text"):SetColor(hudcolor[0],hudcolor[1],hudcolor[2])
		end
		hudflip=1-hudflip
	end
end

function zif_Timer_set(seconds,command)
	local time=timer+seconds
	local action={["timer"]=time,["command"]=command}
	local before=1
	for t=1,#timer_action,1 do
		if time<timer_action[t]["timer"] then 
			before=t
		end
	end
	table.insert(timer_action,before,action)
end

function zif_Timer_execute(command)
	local cmd,parm=zif_parse(command)
	if (cmd=="check1") then
		zif_echo("Und? Alles gut? Ansonsten sag Bescheid auf zifnab.de/tools/rom")
	elseif (cmd=="remind") then
		zif_echo("|cffff0000!! >>>|cff00ffff"..parm.."|cffff0000<<<< !!|r")
		zif_HUD(Zifnabs_Settings.remind,"remind.mp3",parm)
	else
		zif_error("Undefinierter Timer-Befehl "..command)
	end
end

-- ******************************************************************************************
-- * CONFIG
-- ******************************************************************************************

function zif_config(action)
	if action=="start" then
		getglobal("Zifnabs_Config"):Show()
		zif_config_switch("options")
	elseif action=="abort" then
		getglobal("Zifnabs_Config"):Hide()
	elseif config_frames[action] then
		zif_config_switch(action)
	else
		if not action then
			action="*nil*"
		end
		zif_error("Ungültige Config-Aktion '"..action.."'")
	end	
end

function zif_config_switch(action)
	if action=="options" then
		getglobal("Zifnabs_Config_Options_Show"):SetChecked(Zifnabs_Settings.visible)
		getglobal("Zifnabs_Config_Options_ShowRUI"):SetChecked(Zifnabs_Settings.reloadui)
		getglobal("Zifnabs_Config_Options_Monitor_HP_check"):SetChecked(Zifnabs_Settings.monitor_hp.monitor)
		getglobal("Zifnabs_Config_Options_Monitor_HP_value_Text"):SetText(math.ceil(100*Zifnabs_Settings.monitor_hp.value).."%")
		getglobal("Zifnabs_Config_Options_Monitor_HP_HUD"):SetChecked(Zifnabs_Settings.monitor_hp.hud)
		getglobal("Zifnabs_Config_Options_Monitor_HP_Sound"):SetChecked(Zifnabs_Settings.monitor_hp.sound)
		getglobal("Zifnabs_Config_Options_Monitor_Buffs_check"):SetChecked(Zifnabs_Settings.monitor_buffs.monitor)
		getglobal("Zifnabs_Config_Options_Monitor_Buffs_value_Text"):SetText(Zifnabs_Settings.monitor_buffs.value)
		getglobal("Zifnabs_Config_Options_Monitor_Buffs_HUD"):SetChecked(Zifnabs_Settings.monitor_buffs.hud)
		getglobal("Zifnabs_Config_Options_Monitor_Buffs_Sound"):SetChecked(Zifnabs_Settings.monitor_buffs.sound)
		getglobal("Zifnabs_Config_Options_Remind_HUD"):SetChecked(Zifnabs_Settings.remind.hud)
		getglobal("Zifnabs_Config_Options_Remind_Sound"):SetChecked(Zifnabs_Settings.remind.sound)
		zif_config_fps()
	elseif action=="buttons" then
		getglobal("Zifnabs_Config_Buttons_switch_1_2"):SetText("↔")
		getglobal("Zifnabs_Config_Buttons_switch_2_3"):SetText("↔")
		getglobal("Zifnabs_Config_Buttons_switch_4_5"):SetText("↔")
		getglobal("Zifnabs_Config_Buttons_switch_5_6"):SetText("↔")
		getglobal("Zifnabs_Config_Buttons_switch_7_8"):SetText("↔")
		getglobal("Zifnabs_Config_Buttons_switch_8_9"):SetText("↔")
		getglobal("Zifnabs_Config_Buttons_switch_10_11"):SetText("↔")
		getglobal("Zifnabs_Config_Buttons_switch_11_12"):SetText("↔")
		getglobal("Zifnabs_Config_Buttons_switch_1_4"):SetText("↕")
		getglobal("Zifnabs_Config_Buttons_switch_2_5"):SetText("↕")
		getglobal("Zifnabs_Config_Buttons_switch_3_6"):SetText("↕")
		getglobal("Zifnabs_Config_Buttons_switch_4_7"):SetText("↕")
		getglobal("Zifnabs_Config_Buttons_switch_5_8"):SetText("↕")
		getglobal("Zifnabs_Config_Buttons_switch_6_9"):SetText("↕")
		getglobal("Zifnabs_Config_Buttons_switch_7_10"):SetText("↕")
		getglobal("Zifnabs_Config_Buttons_switch_8_11"):SetText("↕")
		getglobal("Zifnabs_Config_Buttons_switch_9_12"):SetText("↕")
		for b=1,99,1 do
			if getglobal("Zifnabs_Config_Buttons_"..b) then
				local text=Zifnabs_Settings["button"][b]
				getglobal("Zifnabs_Config_Buttons_"..b):SetText(text)
				getglobal("Zifnabs_Config_Buttons_"..b):Show()
			end
		end
		getglobal("Zifnabs_Config_Buttons_Edit"):Hide()
	elseif action=="texts" then
		zif_config_text_display(Zifnabs_Settings["button"][1],arrange_categories[1])
	elseif action=="timer" then
		
	else
		zif_error("Wechsel zu undefiniertem Register "..action)
	end
	for caction,cregister in pairs(config_frames) do
		if action==caction then
			getglobal("Zifnabs_Config_"..cregister):Show()
			getglobal("Zifnabs_Config_Select_"..cregister):Hide()
			getglobal("Zifnabs_Config_Selected_"..cregister):Show()
		else
			getglobal("Zifnabs_Config_"..cregister):Hide()
			getglobal("Zifnabs_Config_Select_"..cregister):Show()
			getglobal("Zifnabs_Config_Selected_"..cregister):Hide()
		end
	end
end

-- OPTIONS

function zif_config_check(checkbox)
	local checker,name,part=zif_getname(checkbox)
	local value=checkbox:IsChecked()
	if checker=="options_show" then
		zif_config_set_show(value)
	elseif checker=="options_showrui" then
		Zifnabs_Settings.reloadui=value
		zif_display()
	elseif checker=="hp_check" then
		Zifnabs_Settings.monitor_hp.monitor=value
	elseif checker=="buffs_check" then
		Zifnabs_Settings.monitor_buffs.monitor=value
	elseif checker=="fps_check" then
		Zifnabs_Settings.monitor_fps.monitor=value
		zif_display()
	elseif checker=="hp_hud" then
		Zifnabs_Settings.monitor_hp.hud=value
	elseif checker=="hp_sound" then
		Zifnabs_Settings.monitor_hp.sound=value
	elseif checker=="buffs_hud" then
		Zifnabs_Settings.monitor_buffs.hud=value
	elseif checker=="buffs_sound" then
		Zifnabs_Settings.monitor_buffs.sound=value
	elseif checker=="remind_hud" then
		Zifnabs_Settings.remind.hud=value
	elseif checker=="remind_sound" then
		Zifnabs_Settings.remind.sound=value		
	end
end

function zif_config_set_show(value)
	Zifnabs_Settings.visible=value
	zif_display()
	if value==false then
		zif_echo("wird nicht mehr angezeigt. Anzeige wieder aktivieren mit /zif show")
	end
end

function zif_config_buffs(widget)
	local dummy,name,part=zif_getname(widget)
	local buftime=Zifnabs_Settings.monitor_buffs.value
	if part[#part]=="plus" then
		buftime=buftime+1
	else
		buftime=math.max(1,buftime-1)
	end
	Zifnabs_Settings.monitor_buffs.value=buftime
	getglobal("Zifnabs_Config_Options_Monitor_Buffs_value_Text"):SetText(buftime)
end

function zif_config_hp(widget)
	local dummy,name,part=zif_getname(widget)
	local hpwarn=100*Zifnabs_Settings.monitor_hp.value
	if part[#part]=="plus" then
		hpwarn=hpwarn+1
	else
		hpwarn=math.max(1,hpwarn-1)
	end
	Zifnabs_Settings.monitor_hp.value=hpwarn/100
	getglobal("Zifnabs_Config_Options_Monitor_HP_value_Text"):SetText(hpwarn.."%")
end

function zif_config_fps(widget)
	local red=Zifnabs_Settings.monitor_fps.red
	local yellow=Zifnabs_Settings.monitor_fps.yellow
	local green=Zifnabs_Settings.monitor_fps.green
	if widget then
		local dummy,name,part=zif_getname(widget)
		local cl=part[#part-1]
		local delta=part[#part]
		if cl=="red" and delta=="plus" then
			red=math.min(38,red+1)
			yellow=math.max(yellow,red+1)
			green=math.max(green,yellow+1)
		elseif cl=="red" and delta=="minus" then
			red=math.max(1,red-1)
		elseif cl=="yellow" and delta=="plus" then
			yellow=math.min(39,yellow+1)
			green=math.max(green,yellow+1)
		elseif cl=="yellow" and delta=="minus" then
			yellow=math.max(2,yellow-1)
			red=math.min(red,yellow-1)
		elseif cl=="green" and delta=="plus" then
			green=math.min(40,green+1)
		elseif cl=="green" and delta=="minus" then
			green=math.max(3,green-1)
			yellow=math.min(yellow,green-1)
			red=math.min(red,yellow-1)
		end
		Zifnabs_Settings.monitor_fps.red=red
		Zifnabs_Settings.monitor_fps.yellow=yellow
		Zifnabs_Settings.monitor_fps.green=green
	end
	getglobal("Zifnabs_Config_Options_Monitor_FPS_red_value_Text"):SetText(red)
	getglobal("Zifnabs_Config_Options_Monitor_FPS_yellow_value_Text"):SetText(yellow)
	getglobal("Zifnabs_Config_Options_Monitor_FPS_green_value_Text"):SetText(green)
	getglobal("Zifnabs_Config_Options_Monitor_FPS_red_value_Text"):SetColor(1,0,0)
	getglobal("Zifnabs_Config_Options_Monitor_FPS_yellow_value_Text"):SetColor(1,1,0)
	getglobal("Zifnabs_Config_Options_Monitor_FPS_green_value_Text"):SetColor(0,1,0)
	getglobal("Zifnabs_Config_Options_Monitor_FPS_check"):SetChecked(Zifnabs_Settings.monitor_fps.monitor)
end

-- BUTTONS

function zif_config_button(widget)
	zif_config_switch("buttons")
	local dummy,name,part=zif_getname(widget)
	edit_button=tonumber(part[#part])
	local edit=getglobal("Zifnabs_Config_Buttons_Edit")
	local point, relativePoint, relativeTo, x, y = widget:GetAnchor()
	edit:ClearAllAnchors()
	edit:SetAnchor(point, relativePoint, relativeTo, x, y)
	local text=widget:GetText()
	edit:SetText(text)
	widget:Hide()
	edit:Show()
	edit:SetFocus()
end

function zif_config_button_save()
	local caption=string.lower(getglobal("Zifnabs_Config_Buttons_Edit"):GetText())
	local exist=0
	for number,text in pairs(Zifnabs_Settings["button"]) do
		if text==caption then 
			exist=number
		end
	end
	if exist==edit_button then
		zif_echo("Keine Änderung")
	elseif exist>0 then
		zif_error("Button "..caption.." existiert bereits!")
	elseif Zifnabs_Settings["button"][edit_button] then
		local oldcaption=Zifnabs_Settings["button"][edit_button]
		Zifnabs_Settings["button"][edit_button]=caption
		Zifnabs_Settings["say"][caption]=Zifnabs_Settings["say"][oldcaption]
		Zifnabs_Settings["say"][oldcaption]=nil
	else
		local newcategory={["notarget"]={},["any"]={},["female"]={},["male"]={}}
		Zifnabs_Settings["say"][caption]=newcategory
		Zifnabs_Settings["button"][edit_button]=caption
	end
	zif_display()
	zif_config_switch("buttons")
end

function zif_config_button_switch(widget)
	local dummy,name,part=zif_getname(widget)
	local b1=tonumber(part[#part])
	local b2=tonumber(part[#part-1])
	local text1=Zifnabs_Settings["button"][b1]
	local text2=Zifnabs_Settings["button"][b2]
	Zifnabs_Settings["button"][b1]=text2
	Zifnabs_Settings["button"][b2]=text1
	zif_display()
	zif_config_switch("buttons")
end

-- TEXTS

function zif_config_text_switch(widget)
	local dummy,name,part=zif_getname(widget)
	local bbutton=getglobal("Zifnabs_Config_Texts_Next_Button"):GetText()
	local cbutton=getglobal("Zifnabs_Config_Texts_Next_Category"):GetText()
	if part[#part]=="Button" then
		local bnew=bbutton
		for b=1,#Zifnabs_Settings["button"],1 do
			if Zifnabs_Settings["button"][b]==bbutton then
				if b<#Zifnabs_Settings["button"] then
					bnew=Zifnabs_Settings["button"][b+1]
				else
					bnew=Zifnabs_Settings["button"][1]
				end
			end
		end
		zif_config_text_display(bnew,cbutton)
	else
		local cnew=cbutton
		for c=1,#arrange_categories,1 do
			if arrange_categories[c]==cbutton then
				if c<#arrange_categories then
					cnew=arrange_categories[c+1]
				else
					cnew=arrange_categories[1]
				end
			end
		end
		zif_config_text_display(bbutton,cnew)
	end
end

function zif_config_text_display(button,category)
	local bbutton=getglobal("Zifnabs_Config_Texts_Next_Button")
	local cbutton=getglobal("Zifnabs_Config_Texts_Next_Category")
	bbutton:SetText(button)
	cbutton:SetText(category)
	for i=1,99,1 do
		local editbox=getglobal("Zifnabs_Config_Texts_Text_"..i)
		if editbox then
			editbox:SetText(Zifnabs_Settings["say"][button][category][i])
		end
	end
end

function zif_config_text_save(widget)
	local dummy,name,part=zif_getname(widget)
	local nr=tonumber(part[#part])
	local button=getglobal("Zifnabs_Config_Texts_Next_Button"):GetText()
	local category=getglobal("Zifnabs_Config_Texts_Next_Category"):GetText()
	local text=widget:GetText()
	if text=="" then
		table.remove(Zifnabs_Settings["say"][button][category],nr)
	else
		local highest=0
		for i=1,nr,1 do
			if Zifnabs_Settings["say"][button][category][i] then
				highest=i
			end
		end
		nr=math.min(nr,highest+1)
		Zifnabs_Settings["say"][button][category][nr]=text
	end
	zif_config_text_display(button,category)
end

-- ******************************************************************************************
-- * DISPLAY
-- ******************************************************************************************

function zif_display()
	getglobal("Zifnabs_Config_Release_Text"):SetText(Zifnabs_release)
	local lastbuttonrow=0
	for b=1,99,1 do
		local button=getglobal("Zifnabs_Button_"..b)
		local text=Zifnabs_Settings["button"][b]
		if button and text then
			button:SetText(text)
			button:Show()
			lastbuttonrow=b
		elseif button then
			button:Hide()
		elseif text then
			zif_error("Kein Button "..b.." vorhanden für "..text)
		end
	end
	getglobal("Zifnabs"):SetHeight(22+math.ceil(lastbuttonrow/3)*20)
	Zifnabs_Settings["release"]=Zifnabs_release
	if Zifnabs_Settings["reloadui"]==true then
		getglobal("Zifnabs_ReloadUI"):Show()
	else
		getglobal("Zifnabs_ReloadUI"):Hide()
	end
	local me=getglobal("Zifnabs")
	if Zifnabs_Settings["visible"]==true then
		getglobal("Zifnabs"):Show()
	else
		getglobal("Zifnabs"):Hide()
	end
	if Zifnabs_Settings.monitor_fps.monitor==true then
		getglobal("Zifnabs_FPS"):Show()
	else
		getglobal("Zifnabs_FPS"):Hide()
	end
	getglobal("Zifnabs_Error"):Hide()
end

function zif_HUD(checktable,mp3,text)
	if checktable.sound==true then
		PlaySoundByPath("Interface/Addons/Zifnabs/"..mp3)
	end
	if checktable.hud==true then
		local hud=getglobal("Zifnabs_HUD")	
		local hudtext=getglobal("Zifnabs_HUD__Text")
		hudtime=7
		hudcolor[0]=1
		hudcolor[1]=1
		hudcolor[2]=0
		hudtext:SetColor(hudcolor[0],hudcolor[1],hudcolor[2])
		hudtext:SetText(text)
	
		hud:ClearAllAnchors()
		hud:SetAnchor("CENTER","CENTER","UIParent",0,180)
		hud:Show()
	end
end

function zif_echo(text)
	if not text then
		text="*nil*"
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cffe09000Zifnabs: |r"..text)
end
function zif_error(text)
	DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Zifnabs: "..text.."|r")
end

-- ******************************************************************************************
-- * ACTION
-- ******************************************************************************************

function zif_button(widget)
	local dummy,name,part=zif_getname(widget)
	local number=tonumber(part[#part])
	if Zifnabs_Settings["button"][number] then
		zif_tell(Zifnabs_Settings["button"][number])
	else
		zif_error("Button "..number.." ist nicht definiert")
	end
end

function zif_tell(button)
	local tbl1={}
	local tbl2={}
	local message=""
	if (UnitExists("target")) then
		tbl1=Zifnabs_Settings["say"][button]["any"]
		if UnitIsPlayer("target") and UnitSex("target")==0 then
			tbl2=Zifnabs_Settings["say"][button]["male"]
		elseif UnitIsPlayer("target") and UnitSex("target")==1 then
			tbl2=Zifnabs_Settings["say"][button]["female"]
		end
	else
		tbl1=Zifnabs_Settings["say"][button]["notarget"]
	end
	local mi=math.random(#tbl1+#tbl2)
	if mi<=#tbl1 then
		message=tbl1[mi]
	else
		message=tbl2[mi-#tbl1]
	end
	if message then
		SendChatMessage(message, "SAY", 0);
	else
		zif_error("interner Fehler, keine Meldung generiert")
	end
end

-- ******************************************************************************************
-- * FUNCTIONS
-- ******************************************************************************************

function zif_parse(text)
	local blank=string.find(text," ")
	local parm=""
	if blank then
		parm=string.sub(text,blank+1)
		text=string.lower(string.sub(text,1,blank-1))
	end
	return text,parm
end

function zif_getname(widget)
	local name=string.gsub(widget:GetName(),"_"," ")
	local part={}
	for word in string.gmatch(name, "%w+") do
		part[#part+1]=word
	end
	return string.lower(part[#part-1].."_"..part[#part]),name,part
end
